<%@ LANGUAGE="VBSCRIPT" %>
<!-- #include file="adovbs.inc" -->
<%	Response.Buffer=False
	'Increase timeout for DNS operations
	Server.ScriptTimeout = 150

	'Set how much debug output to display.
	'Production setting = 0, Errors only=1, Status messages=2, Lots of info=3
	nDebugLevel = 3
	
	'Initialize Variables
	bContinue = True
	CleanupAccounts = False
	CleanupDNS = False
	CleanupVS = False
	gstrVSNumber = "0"
	gVSRecord = 0
	gIPRecord = 0
	sError=""
	ShowErrMsg = True

	EVENTLOG_SUCCESS_TYPE = 0
	EVENTLOG_ERROR_TYPE = 1
	EVENTLOG_WARNING_TYPE = 2
	EVENTLOG_INFORMATION_TYPE = 4
	EVENTLOG_AUDIT_SUCCESS = 8
	EVENTLOG_AUDIT_FAILURE = 10
%>
<!--#INCLUDE FILE="strings.inc"-->
<html>

<head>
<meta http-equiv="Content-Type"
content="text/html; charset=iso-8859-1">
<meta name="description" content="Sample Sign-up Server">
<meta name="GENERATOR"
content="Microsoft FrontPage (Visual InterDev Edition) 2.0">
<title><%=L_PageTitle_Text%></title>

</head>

<body background="images/backg16.gif" topmargin="0" leftmargin="0">
<table border="0" cellpadding="0" cellspacing="0" width="100%">
    <tr>
        <td valign="top" width="100">
		<img src="images/MSsmallb.gif"
        alt="<%=L_ProgramTitle_Text%>" width="100"
        height="100"></td>
        <td valign="top"><div style="margin-top: 10px; margin-left: 10px"><img src="images/rksignup.gif" alt="<%=L_ProgramTitle_Text%>" width=271 height=65> </td>
        <td align="right" valign="bottom"><div style="margin-right: 20px">
<img
        src="images/logosm2.gif"
        alt="<%=L_ApplicationTitle_Text%>" vspace="10"
        width="162" height="39"><br clear="all">
        </td>
    </tr>
    <tr>
        <td colspan="3" bgcolor="#000000" height="1">
		</td>
    </tr>
</table>

<p>
<%If Session("RefFinish") = "True" Then
  'This page has already been submitted once%>
	<font size="2" face="Verdana" color="800000"><strong>
		 <%=L_RefFinish_Text%>
	</strong></font>
<%Else%>
<div align="center"><center>

<table border="0" width="90%">
    <tr>
        <td valign="top"><font size="2" face="Verdana"color="800000"><strong>
		<%=L_SysBeingConfigured_Text%></strong></font>
		</td>
	</tr>
</table>
</center></div>

<div align="center"><center>

<table border="0" width="90%">
    <tr>
		<td valign="top">
			<font size="2" face="Verdana">
<%    '************************************************************
      'Create the object which does all of the work for us.
	  On Error Resume Next

      if (bContinue) then
        set oIspSetup = Server.CreateObject("IspSignup.IspSetup")

        if (Err.Number <> 0) then
          bContinue = False
		  sError = "ERROR Creating ISP Setup Object on Server (" & err.number & "): " & err.description
          if (nDebugLevel > 0) then
            response.write sError & Chr(46) & "<br>"
          end if
        end if    'Err.Number <> 0
      end if    'bContinue = True

      '************************************************************
      'Logon to an account with sufficient privileges to do the work.
      if (bContinue) then
		bContinue = LogonUser (Session("MachineDomainName"), Session("RunAsUID"), Session("RunAsPasswd"))
      end if    'bContinue = True

      '************************************************************
      'Create the specified user.
      if (bContinue) then
        bContinue = CreateUser()
      end if

      '************************************************************
      'Create the Front Page user (if different than dial-in user account).
      if (bContinue) then
        bContinue = CreateFrontPageUser()
      end if    'bContinue = True

      '************************************************************
      'Insert the required DNS entries.
      if (bContinue) then
		CleanupAccounts = True
        bContinue = AddDnsRecords()
      End If      'bContinue = True

      '************************************************************
      'Hook up to IIS
      if (bContinue) then
	    CleanupDNS = True
        bContinue = ConfigureIis()
      end if      'bContinue = True

      '............................................................
      'Add another A record for the 2nd-level domain name to point to when it is added
      if (bContinue) then
	  	CleanupVS = True
        bContinue = Add2ndLevelDomainARecord (Session("sVsIp"))
		oIspSetup.DnsIncrementZoneVersion Session("NS1Internic"), Session("BaseDnsName")
        oIspSetup.DnsIncrementZoneVersion Session("NS1etrn"), Session("BaseDnsName")
      end if      'bContinue = True

      '************************************************************
      ' Get Permanent IP Address from database.
      if ((bContinue) and (Session("UseStaticIP") = "True")) then
        bContinue = GetIpAddrFromDb()
      end if      'bContinue = True and UseStaticIP
	  
	  '************************************************************
      ' Log new user account to database
	  if (bContinue) then
        bContinue = LogUserAccount()
      end if      'bContinue = True

      '************************************************************
      'Clean up: remove user accounts if we failed; delete object.
      '************************************************************  -->

      if (bContinue = False) then
        if (CleanupAccounts) Then    'The error occurred after account creation.
          'Remove the user accounts which were created.
          oIspSetup.DeleteUser Session("MachineDomainName"), Session("UserName")
          oIspSetup.DeleteUser Session("MachineDomainName"), Session("FrontPageUserName")
        end if
		if (CleanupDNS) Then    'The error occurred after DNS record creation.
          'Remove the DNS entries which were created.
          oIspSetup.DnsDeleteMxRecord CStr(Session("NS1Internic")), CStr(Session("ThirdLevelDomainName")), CStr(Session("ISPMailServer")), 0
          oIspSetup.DnsDeleteMxRecord CStr(Session("NS1etrn")), CStr(Session("ThirdLevelDomainName")), CStr(Session("RandomMachineName")), 0
		  oIspSetup.DnsDeleteMxRecord CStr(Session("NS1etrn")), CStr(Session("ThirdLevelDomainName")), CStr(Session("ISPMailServer")), 20
		  sDnsData = "www" & Chr(46) & CStr(Session("ThirdLevelDomainName"))
		  oIspSetup.DnsDeleteARecord CStr(Session("NS1Internic")), CStr(sDnsData), CStr(Session("sVsIp"))
		  oIspSetup.DnsIncrementZoneVersion CStr(Session("NS1Internic")), CStr(Session("BaseDnsName"))
		  oIspSetup.DnsIncrementZoneVersion CStr(Session("NS1etrn")), CStr(Session("BaseDnsName"))
        end if
		if (CleanupVS)   Then			'The error occurred after VS creation.
		  if Session("UseIIS4") = "True" Then
			  oIspSetup.DeleteVirtualServer CStr(Session("WebServer")), gstrVSNumber
			  If Session("CreateFTPRoot") = "True" Then
				DeleteFTPRootCStr(Session("WebServer")), CStr(Session("FrontPageUserName"))
			  End If
			  RootPath = Session("WebDirRootUNC") & "\" & Session("FrontPageUserName")
			  oIspSetup.AspExtRemoveRemoteDir CStr(RootPath)
		  else
		  	  If Session("UseStaticIP") = "True" Then
		          SQL = "SELECT DISTINCTROW * "
	  			  SQL = SQL & "FROM IpAdd " 
    	          SQL = SQL & "WHERE ID=" & CStr(gIPRecord)
				  
	 			  Set RSIp = Server.CreateObject("ADODB.Recordset")
    	          RSIp.Open SQL, "ISPStaticIP", adOpenDynamic, adLockOptimistic, adCmdText
				  RSIp("Assigned") = False
				  RSIp("AssignedTo") = " "
				  RSIp.Update
              End If			   
			  SQL = "SELECT DISTINCTROW * "
		      SQL = SQL & "FROM [Virtual Servers] "
		  	  SQL = SQL & "WHERE ID=" & CStr(gVSRecord)
		      Set RSIIS = Server.CreateObject("ADODB.Recordset")
  			  RSIIS.Open SQL, "ISPVirtSvr", adOpenDynamic, adLockOptimistic, adCmdText
			  RSIIS("Available") = True
			  RSIIS("Owner") = " "
			  RSIIS.Update
          end if
		end if
	  end if
	  		
      Set oIspSetup = Nothing

      '************************************************************
      'Write the user info to a file on the server.
      '************************************************************  -->
      if Not bContinue AND ShowErrMsg Then
		Response.Write "<p><strong><font size=2 color=#800000>"
		Response.Write "Signup failed for the following reason:<BR>"
		Response.Write sError & "<BR>"
		Response.Write "Please contact us for assistance"
		Response.Write "</font></strong>"
		sError = "Sign-Up failed: OrgName = " & Session("OrgName") & ", Contact = " & Session("Contact") & ", UserName = " & Session("UserName") & ", Password = " & Session("Password")
        oIspSetup.AspExtReportEvent CStr(sError), "Sign-Up Server", EVENTLOG_ERROR_TYPE
  	  End If%>

<% if bContinue then %>

<h5><%=L_AccountCreated_Text%></h5>

<h5><%=L_InternetPresence_Text%></h5>

<blockquote>
	<table bgcolor="#e9ddad">
	<tr>
	<td><font size=2><%=L_FullDomainName_Text%> </font></td><td><font size=2><strong><%=Session("ThirdLevelDomainName")%></strong></font></td>
	</tr>
	</table>
</blockquote>
<font size=2>
<p>
<b><%=L_FrontPage_Text%><BR>
<%=L_FrontPage2_Text%><p>
<font color=#800000><%=L_User_Text%> <%=Session("MachineDomainName")%>\<%=Session("FrontPageUserName")%></font><p>
<%=L_Secure_Text%> </b>
</font>
<p><br><br>

<%End If%>
<% if Not bContinue then %>
<form action="cancel.ins" method="GET" name="FinalForm">
		<table border="0" cellpadding="0" cellspacing="0" width="100%">
			<tr>
				<td width="33%">&nbsp;</td>
				<td width="33%">&nbsp;</td>
				<td width="34%" align="left"><input type="submit" value="<%=L_Exit_Text%>" name="Cancel"></td>
			</tr>
		</table>
</form>
<%Else%>
<form action="InsFile.asp" method="GET" name="FinalForm">
<table border="0" cellpadding="15" cellspacing="0" width="100%">
	<tr>
		<td align="right"><font size=2 color="#800000"><br><strong><%=L_ClickHere_Text%></strong><p></font></td>
		<td align="left"><input type="submit" value="<%=L_Finish_Text%>" name="Finish"></td>
	</tr>
</table>
</form>

<%'*******************************************************
  'DO NOT MODIFY CODE BETWEEN * BLOCKS %>

<IMG SRC="http://<%=Session("RefServer")%>/Refer/FinishSU.asp?
ReferralID=<%=Session("ReferralID")%>&OfferID=<%=Session("OfferID")%>">
<%Session("RefFinish") = "True"%>

<%'*******************************************************%>

<%end if%>

</font>
</div>

<%End If%>
</body>

<SCRIPT RUNAT=Server LANGUAGE="VBScript">

'******************************************************************************
'Logon to an account with sufficient privileges to do the work.
'******************************************************************************
Function LogonUser (sDomain, sUserName, sPassword)
	  On Error Resume Next
  LogonUser = True
  if (nDebugLevel > 2) then
    Response.Write "Currently logged in as " & oIspSetup.GetNetUserName
  end if

  oIspSetup.LogonUserAs sDomain & "", sUserName & "", sPassword & ""
  If Err.Number <> 0 Then
	if (nDebugLevel > 0) then
		Response.Write "<br>Error switching security context: " & CStr(Err.Number) & " - " & CStr(Err.Description) & "<br>"
	end if
	LogonUser = False
	sError = "Error switching security context: " & CStr(Err.Number) & " - " & CStr(Err.Description)
	oIspSetup.AspExtReportEvent CStr(sError), "Sign-Up Server", EVENTLOG_ERROR_TYPE
  Else
	sError = "Logged into administrator account"
	oIspSetup.AspExtReportEvent CStr(sError), "Sign-Up Server", EVENTLOG_SUCCESS_TYPE
	if (nDebugLevel > 2) then
		Response.Write "<br>Now logged in as " & oIspSetup.GetNetUserName & "<BR>"
	end if
  End If

End Function

'************************************************************
'Create the specified user.
'************************************************************
Function CreateUser
  On Error Resume Next
  bContinueCreate = True
  AccountMsg = ""

  MsgDuplicate = L_MsgDuplicate1_Text & L_MsgDuplicate2_Text & L_MsgDuplicate3_Text
  MsgError = L_MsgError1_Text & L_MsgError2_Text

  nNameLen = InStr(Session("SelectedDomain"), Chr(46))
  if (nNameLen <> 0) then
	'period (".") found in name
	StrippedDomain = Left(Session("SelectedDomain"), nNameLen - 1) 
  else
	StrippedDomain = Session("SelectedDomain")
  end if

  Session("UserName") = "ppp" & Left(StrippedDomain, 17)
  Session("FrontPageUserName") = Left(StrippedDomain, 20)
  Session("MachineEmailName") = Session("SelectedDomain") & Chr(46) & Session("BaseDnsName")

  bExists = oIspSetup.UserExists (Session("MachineDomainName"), Session("UserName"))
  If Err.Number = 0 Or (Err.Number AND 65535) = 2221 Then
	If (bExists = True) Then
		'Response.Write "<strong>Error: User Account already exists.</strong><p>"
		if (nDebugLevel > 0) then
			Response.Write "<BR><strong>Error: Machine Account (" & Session("UserName") & ") already exists.</strong><p>"
		end if
		AccountMsg = MsgDuplicate
		bContinueCreate = False
		CleanupAccounts = False
		ShowErrMsg = False
		sError = "Error: User Account already exists."
		oIspSetup.AspExtReportEvent CStr(sError), "Sign-Up Server", EVENTLOG_ERROR_TYPE
		Session("RefFinish") = "False"
	End If
  Else 
	if (nDebugLevel > 0) then
		Response.Write "<BR><strong>Error: Error verifying account existance (" & Session("UserName") & ").</strong><p>"
	end if
	AccountMsg = MsgDuplicate
	bContinueCreate = False
	CleanupAccounts = False
	ShowErrMsg = False
	sError = "Error verifying account existance."
	oIspSetup.AspExtReportEvent CStr(sError), "Sign-Up Server", EVENTLOG_ERROR_TYPE
	Session("RefFinish") = "False"
  End If

  Err.Clear 

  if (bContinueCreate) then
    oIspSetup.AddUser Session("MachineDomainName"), Session("UserName"), Session("Password"), Session("NewUserDescription")
    if Err.Number = 0 then
	  sError = "Account created - " & Session("UserName")
	  oIspSetup.AspExtReportEvent CStr(sError), "Sign-Up Server", EVENTLOG_SUCCESS_TYPE
	  if (nDebugLevel > 2) then
        response.write "<br>UID/Password is: <strong>" & Session("UserName") & "/" & Session("Password") & "</strong><br>"
      end if
    else
      if (nDebugLevel > 0) then
        Response.Write "<strong>Error creating account: " & Session("UserName") & "</strong><p>"
      end if
      bContinueCreate = False
      sError = "Error creating account"
	  oIspSetup.AspExtReportEvent CStr(sError), "Sign-Up Server", EVENTLOG_ERROR_TYPE
    end if
  end if    'bContinueCreate = True

  Response.write AccountMsg
  CreateUser = bContinueCreate      'Return the status flag
End Function    'CreateUser


'************************************************************
'* Create the Front Page user (if different than dial-in user account).
Function CreateFrontPageUser
	  On Error Resume Next
  bContinueCreateFPUser = True
  AccountMsg = ""

  MsgDuplicate = L_MsgDuplicate1_Text & L_MsgDuplicate2_Text & L_MsgDuplicate3_Text
  MsgError = L_MsgError1_Text & L_MsgError2_Text

  if (Session("UserName") <> Session("FrontPageUserName")) then
    
  bExists = oIspSetup.UserExists (Session("MachineDomainName"), Session("FrontPageUserName"))
  If Err.Number = 0 Or (Err.Number AND 65535) = 2221 Then
	If (bExists = True) Then
		'Response.Write "<strong>Error: User Account already exists.</strong><p>"
		if (nDebugLevel > 0) then
			Response.Write "<BR><strong>Error: Machine Account (" & Session("FrontPageUserName") & ") already exists.</strong><p>"
		end if
		AccountMsg = MsgDuplicate
		bContinueCreate = False
		CleanupAccounts = False
		ShowErrMsg = False
		sError = "Error: User Account already exists."
		oIspSetup.AspExtReportEvent CStr(sError), "Sign-Up Server", EVENTLOG_ERROR_TYPE
		Session("RefFinish") = "False"
	End If
  Else 
	if (nDebugLevel > 0) then
		Response.Write "<BR><strong>Error: Error verifying account existance (" & Session("FrontPageUserName") & ").</strong><p>"
	end if
	AccountMsg = MsgDuplicate
	bContinueCreate = False
	CleanupAccounts = False
	ShowErrMsg = False
	sError = "Error verifying account existance."
	oIspSetup.AspExtReportEvent CStr(sError), "Sign-Up Server", CInt(EVENTLOG_ERROR_TYPE)
	Session("RefFinish") = "False"
  End If

  Err.Clear
    if (bContinueCreateFPUser) then
	  if (nDebugLevel > 1) then
        response.write "Front Page UID/Password is: <strong>" & Session("FrontPageUserName") & "/" & Session("Password") & "</strong>.<br>"
      end if
      vRetVal = oIspSetup.AddUser(Session("MachineDomainName"), Session("FrontPageUserName"), Session("Password"), Session("NewUserDescription"))
      if Err.Number = 0 then
	    sError = "FrontPage account created - " & Session("FrontPageUserName")
	    oIspSetup.AspExtReportEvent CStr(sError), "Sign-Up Server", CInt(EVENTLOG_SUCCESS_TYPE)
        if (nDebugLevel > 1) then
          Response.Write "Account Successfully Created.<br>"
        end if
      else
        if (nDebugLevel > 0) then
          Response.Write "<strong>Error creating Front Page account: " & Err.Description & "</strong><br>"
        end if
        bContinueCreateFPUser = False
        sError = "Error creating Front Page account: " & Err.Description
		oIspSetup.AspExtReportEvent CStr(sError), "Sign-Up Server", CInt(EVENTLOG_ERROR_TYPE)
 		AccountMsg = MsgError

        oIspSetup.DeleteUser Session("MachineDomainName"), Session("UserName")
        oIspSetup.DeleteUser Session("MachineDomainName"), Session("FrontPageUserName")
     end if '!!!error creating FrontPageUser acc
    end if    'bContinueCreateFPUser = True
  end if    'Username <> FrontPageUserName and bContinue = True

  Response.write (AccountMsg)

  CreateFrontPageUser = bContinueCreateFPUser
End Function    'CreateFrontPageUser


'************************************************************
'Insert the required DNS entries.
Function AddDnsRecords
  On Error Resume Next
  bContinueAddDns = True
	
  err.Clear
  
  oIspSetup.DnsAddMxRecord Session("NS1Internic"), Session("ThirdLevelDomainName"), Session("ISPMailServer"), 0, 3600
  If ( Err.Number = 0 ) Then
    sError = "Success creating MX on Primary DNS for - " & Session("UserName") & Chr(46) & Session("BaseDnsName") & "/" & Session("ISPMailServer")
	oIspSetup.AspExtReportEvent CStr(sError), "Sign-Up Server", CInt(EVENTLOG_SUCCESS_TYPE)
	if (nDebugLevel > 1) then
      Response.Write "Success creating MX on Primary DNS for: " & Session("UserName") & Chr(46) & Session("BaseDnsName") & "/" & Session("ISPMailServer") & "<br>"
      Response.Write "<br>"
    end if    'Debug output
	if (nDebugLevel > 2) then
	    Response.Write "<br>"
		Response.Write "Primary DNS: " & Session("NS1Internic") & "<br>"
		Response.Write "UID/Mail: " & Session("UserName") & Chr(46) & Session("BaseDnsName") & "/" & Session("ISPMailServer") & "<br>"
		Response.Write "<br>"
	end if    'Debug output
  Else
    bContinueAddDns = False
    sError = "Error adding DNS records (MX record on Primary DNS): " & Err.Description
  End If

  if (bContinueAddDns) then
    err.Clear
	
	RandomString = oIspSetup.GeneratePassword
     
    For j = 1 To Len(RandomString)
        c = Mid(RandomString, j, 1)
        If IsNumeric(c) Then
            If ((c >= 0) And (c <= 9)) Then
                TempString = TempString & Mid(RandomString, j, 1)
            End If
        Else
            If ((c >= "a") And (c <= "z")) Or ((c >= "A") And (c <= "Z")) Then
                TempString = TempString & Mid(RandomString, j, 1)
            End If
        End If
    Next
    
    If Len(TempString) < 15 Then
        Randomize
        For i = (Len(TempString) + 1) To 15
            TempString = TempString & CStr(Int(10 * Rnd))
        Next
    End If
    
    Session("RandomMachineName") = Left(TempString,15)
    Session("RandomMachineName") = Session("RandomMachineName") & Chr(46) & Session("BaseDnsName")
	
	oIspSetup.DnsAddMxRecord Session("NS1etrn"), Session("ThirdLevelDomainName"), Session("RandomMachineName"), 0, 1
    If ( Err.Number = 0 ) Then
      vRedoMx2 = False
	  sError = "Success adding MX record on ETRN DNS for " & Session("UserName") & Chr(46) & Session("BaseDnsName") & "/" & Session("MachineEmailName")
	  oIspSetup.AspExtReportEvent CStr(sError), "Sign-Up Server", CInt(EVENTLOG_SUCCESS_TYPE)
	  if (nDebugLevel > 1) then
        Response.Write "Success adding MX record on ETRN DNS for " & Session("UserName") & Chr(46) & Session("BaseDnsName") & "/" & Session("MachineEmailName")
        Response.Write "<br>"
      end if    'Debug output
	  if (nDebugLevel > 2) then
		Response.Write "ETRN DNS: " & Session("NS1etrn") & "<br>"
		Response.Write "UID/Mail: " & Session("UserName") & Chr(46) & Session("BaseDnsName") & "/" & Session("MachineEmailName")
        'Response.Write Chr(46) & Session("BaseDnsName") & "<br>"
		Response.Write "<br>"
	  end if    'Debug output
    Else
      bContinueAddDns = False
      sError = "Error adding DNS records (MX record on ETRN DNS): " & Err.Description
	  oIspSetup.AspExtReportEvent CStr(sError), "Sign-Up Server", CInt(EVENTLOG_ERROR_TYPE)
    End If
  End If      'bContinueAddDns = True

  if (bContinueAddDns) then
    err.Clear
	oIspSetup.DnsAddMxRecord Session("NS1etrn"), Session("ThirdLevelDomainName"), Session("ISPMailServer"), 20, 1
    If ( Err.Number = 0 ) Then
      vRedoMx2 = False
	  sError = "Success adding second MX record on ETRN DNS for " & Session("UserName") & Chr(46) & Session("BaseDnsName") & "/" & Session("MachineEmailName")
	  oIspSetup.AspExtReportEvent CStr(sError), "Sign-Up Server", CInt(EVENTLOG_SUCCESS_TYPE)
	  if (nDebugLevel > 1) then
        Response.Write sError
        Response.Write "<br>"
      end if    'Debug output
    Else
      bContinueAddDns = False
      sError = "Error adding DNS records (Second MX record on ETRN DNS): " & Err.Description
	  oIspSetup.AspExtReportEvent CStr(sError), "Sign-Up Server", CInt(EVENTLOG_ERROR_TYPE)
    End If
  End If      'bContinueAddDns = True
  
  if (CleanupDNS) Then    'The error occurred after DNS record creation.
  	'Remove the DNS entries which were created.
    oIspSetup.DnsDeleteMxRecord CStr(Session("NS1Internic")), CStr(Session("ThirdLevelDomainName")), CStr(Session("ISPMailServer")), 0
    oIspSetup.DnsDeleteMxRecord CStr(Session("NS1etrn")), CStr(Session("ThirdLevelDomainName")), CStr(Session("RandomMachineName")), 0
	oIspSetup.DnsDeleteMxRecord CStr(Session("NS1etrn")), CStr(Session("ThirdLevelDomainName")), CStr(Session("ISPMailServer")), 20
  end if
  
  AddDnsRecords = bContinueAddDns
End Function    'AddDnsRecords

'..................................................
'Add another A record for the 2nd-level domain name to point to when it is added
'..................................................
Function Add2ndLevelDomainARecord (sVsIp)
	  On Error Resume Next
  bContinue2ndLvlARec = True

  if (nDebugLevel > 2) then
    response.write "IP Addr of virtual server is " & sVsIp & ";  "
  end if

  sDnsData = "www" & Chr(46) & Session("ThirdLevelDomainName")
  err.clear
  oIspSetup.DnsAddARecord CStr(Session("NS1Internic")), CStr(sDnsData), CStr(sVsIp), 3600
  If (Err.Number <> 0) Then
  	err.clear
  	oIspSetup.DnsAddARecord CStr(Session("NS1Internic")), CStr(sDnsData), CStr(sVsIp), 3600
	If (Err.Number <> 0) Then
  		sError = "ERROR Adding A Record for Virtual Server" & " - " & CStr(Err.Description)
		oIspSetup.AspExtReportEvent CStr(sError), "Sign-Up Server", CInt(EVENTLOG_ERROR_TYPE)
		bContinue2ndLvlARec = False
	else
	  	sError = "Success adding A record for virtual server"
		oIspSetup.AspExtReportEvent CStr(sError), "Sign-Up Server", CInt(EVENTLOG_SUCCESS_TYPE)
		if (nDebugLevel > 1) then
    	    Response.Write sError
	    	Response.Write "<br>"
		end if
		End If
  else
  	sError = "Success adding A record for virtual server"
	oIspSetup.AspExtReportEvent CStr(sError), "Sign-Up Server", CInt(EVENTLOG_SUCCESS_TYPE)
	if (nDebugLevel > 1) then
        Response.Write sError
	    Response.Write "<br>"
    end if    'Debug output
  End If
	
Add2ndLevelDomainARecord = bContinue2ndLvlARec
End Function    'Add2ndLevelDomainARecord


'************************************************************
'Hook up to IIS
Function ConfigureIis
  On Error Resume Next
  bContinueConfigIis = True

  if (nDebugLevel > 2) then
  	response.write "calling config VS with DNS Server: " & Session("NS1Internic") & "<br>"
	response.write "A Record Zone: " & "www" & Chr(46) & Session("ThirdLevelDomainName") & "<br>"
  end if    'Debug output
  Err.Clear
  
  If Session("UseIIS4") = "True" Then
    RootDir = CStr(Session("WebDirRootUNC")) & "\" & CStr(Session("FrontPageUserName"))
    oIspSetup.AspExtCreateRemoteDir CStr(RootDir)
	if (err.number <> 0) then
		if (nDebugLevel > 0) then
			response.write "<p>Error creating remote directory (" & RootDir & "): " & err.number & " - " & err.description & "<br>"
		end if
		bContinueConfigIis = False
		sError = "ERROR Creating remote directory (" & RootDir & "): " & err.number & " - " & err.description
		oIspSetup.AspExtReportEvent CStr(sError), "Sign-Up Server", CInt(EVENTLOG_ERROR_TYPE)
	else
		sError = "Success creating remote directory - " & Session("WebServer") & " - " & Session("WebDirRoot") & "\" & Session("FrontPageUserName")
		oIspSetup.AspExtReportEvent CStr(sError), "Sign-Up Server", CInt(EVENTLOG_SUCCESS_TYPE)
	end if
	
	If bContinueConfigIis Then
		RootPath = Session("WebDirRootUNC") & "\" & Session("FrontPageUserName")
		oIspSetup.AspExtAddAccessRights CStr(RootPath), Session("MachineDomainName") & "\" & Session("FrontPageUserName")
		if (err.number <> 0) then
			if (nDebugLevel > 0) then
				response.write "<p>Error adding access rights to directory (" & RootPath & "): " & err.number & " - " & err.description & "<br>"
			end if
			bContinueConfigIis = False
			sError = "Error adding access rights to directory (" & RootPath & "): " & err.number & " - " & err.description
			oIspSetup.AspExtReportEvent CStr(sError), "Sign-Up Server", CInt(EVENTLOG_ERROR_TYPE)
		else
			sError = "Success adding access rights to directory (" & RootPath & ")"
			oIspSetup.AspExtReportEvent CStr(sError), "Sign-Up Server", CInt(EVENTLOG_SUCCESS_TYPE)
		end if
	End If
	
	If bContinueConfigIis Then
		if Session("UseFrontPageExt") = "True" Then
			UseFP = True
		else
			UseFP = False
		end if
		Session("HostHeaderName") = "www" & Chr(46) & Session("ThirdLevelDomainName")
	  	gstrVSNumber = oIspSetup.CreateVirtualServer(CStr(Session("WebServer")), CStr(Session("HostHeaderName")), CStr(Session("HTTPPort")), "", CBool(UseFP), CStr(Session("WebDirRoot")))
		if (Err.Number <>0) then
			if (nDebugLevel > 0) then
				response.write "<p>Error creating Web Virtual Server (" & Session("WebServer") & "): " & err.number & " - " & err.description & "<br>"
			end if
			bContinueConfigIis = False
			sError = "Error creating Web Virtual Server (" & Session("WebServer") & "): " & err.number & " - " & err.description
			oIspSetup.AspExtReportEvent CStr(sError), "Sign-Up Server", CInt(EVENTLOG_ERROR_TYPE)
		else
			sError = "Success creating Web Virtual Server - " & Session("WebServer")
			oIspSetup.AspExtReportEvent CStr(sError), "Sign-Up Server", CInt(EVENTLOG_SUCCESS_TYPE)
		end if
	End If
	
	If bContinueConfigIis And Session("CreateFTPRoot") = "True" Then
		oIspSetup.CreateFTPRoot CStr(Session("WebServer")), CStr(Session("FrontPageUserName")), CStr(Session("WebDirRoot"))
		if (Err.Number <>0) then
			if (nDebugLevel > 0) then
				response.write "<p>Error creating FTP virtual directory (" & CStr(Session("FrontPageUserName")) & "): " & err.number & " - " & err.description & "<br>"
			end if
			bContinueConfigIis = False
			sError = "Error creating FTP virtual directory (" & CStr(Session("FrontPageUserName")) & "): " & err.number & " - " & err.description
			oIspSetup.AspExtReportEvent CStr(sError), "Sign-Up Server", CInt(EVENTLOG_ERROR_TYPE)
		else
			sError = "Success creating FTP virtual directory - " & CStr(Session("FrontPageUserName"))
			oIspSetup.AspExtReportEvent CStr(sError), "Sign-Up Server", CInt(EVENTLOG_SUCCESS_TYPE)
		end if
	End If

	Err.Clear
	oIspSetup.AddUserToGroup Session("MachineDomainName"), Session("FrontPageUserName"), "Guests"
	if (err.number <> 0) then
		if (nDebugLevel > 0) then
			response.write "Error adding user to group (" & "Guests" & "): " & err.number & "<br>"
		end if
		bContinueConfigIis = False
		sError = "ERROR adding user to group (" & "Guests" & "): " & err.number
		oIspSetup.AspExtReportEvent CStr(sError), "Sign-Up Server", CInt(EVENTLOG_ERROR_TYPE)
	else
		sError = "Success adding user to group - " & "Guests"
		oIspSetup.AspExtReportEvent CStr(sError), "Sign-Up Server", CInt(EVENTLOG_SUCCESS_TYPE)
	end if
	
    	Session("sVsIp") = Session("WebServerIP")
	
	If Not bContinueConfigIis Then
		oIspSetup.DeleteVirtualServer CStr(Session("WebServer")), gstrVSNumber
		If Session("CreateFTPRoot") = "True" Then
			DeleteFTPRoot CStr(Session("WebServer")), CStr(Session("FrontPageUserName"))
		End If
		RootPath = Session("WebDirRootUNC") & "\" & Session("FrontPageUserName")
		oIspSetup.AspExtRemoveRemoteDir CStr(RootPath)
		Err.Clear
	End If
  Else
    'IIS 3.0
    SQL = "SELECT DISTINCTROW * "
  	SQL = SQL & "FROM [Virtual Servers] "
  	SQL = SQL & "WHERE [Virtual Servers].Available=True"
  	Set RSIIS = Server.CreateObject("ADODB.Recordset")
  	RSIIS.Open SQL, "ISPVirtSvr", adOpenDynamic, adLockOptimistic, adCmdText
  
  	If RSIIS.EOF AND RSIIS.BOF Then
    	sError = "ERROR Configuring IIS Virtual Server: No available servers in database."
		oIspSetup.AspExtReportEvent CStr(sError), "Sign-Up Server", CInt(EVENTLOG_ERROR_TYPE)
    	bContinueConfigIis = False
  	Else
		RSIIS.MoveFirst
		gVSRecord = rsIIS("ID")
		sFrontPageGroup = rsIIS("AuthoringGroup")
		sVsIp = rsIIS("IP")
		Session("Directory") = rsIIS("Directory")
		RSIIS("Available") = False
		RSIIS("Owner") = Session("UserName")
		RSIIS.Update
		sError = "Success configuring virtual server IP address - " & sVsIp
		oIspSetup.AspExtReportEvent CStr(sError), "Sign-Up Server", CInt(EVENTLOG_SUCCESS_TYPE)
  	End If
  
  	RSIIS.Close

  	Session("FrontPageGroup") = sFrontPageGroup
  	Session("sVsIp") = sVsIp
  
  	If bContinueConfigIis Then
		if (nDebugLevel > 1) then
			response.write "Success creating front page account.  Will now attemp to add to auth Group: " & Session("FrontPageGroup") & "<br>"
			response.write "Front Page Group: " & Session("FrontPageGroup") & "<br>"
		end if    'Debug output
		'Add user to Front Page authoring group
		if (nDebugLevel > 1) then
			response.write "FP User/Group: " & Session("FrontPageUserName") & "/" & Session("FrontPageGroup") & "<br>"
		end if

		Err.Clear
		oIspSetup.AddUserToGroup Session("MachineDomainName"), Session("FrontPageUserName"), sFrontPageGroup
		if (err.number <> 0) then
			if (nDebugLevel > 0) then
				response.write "Error adding FP user to group (" & Session("FrontPageGroup") & "): " & err.number & "<br>"
			end if
			bContinueConfigIis = False
			sError = "ERROR adding user to web authoring group (" & Session("FrontPageGroup") & "): " & err.number
			oIspSetup.AspExtReportEvent CStr(sError), "Sign-Up Server", CInt(EVENTLOG_ERROR_TYPE)
		else
			sError = "Success adding FrontPage User to group - " & sFrontPageGroup
			oIspSetup.AspExtReportEvent CStr(sError), "Sign-Up Server", CInt(EVENTLOG_SUCCESS_TYPE)
		end if

 	 End If
  End If
  
  ConfigureIis = bContinueConfigIis
End Function    'ConfigureIis

'************************************************************
' Get Permanent IP Address from database.
Function GetIpAddrFromDb
	  On Error Resume Next
  bContinueGetIp = True
  
  SQL = "SELECT DISTINCTROW * "
  SQL = SQL & "FROM IpAdd " 
  SQL = SQL & "WHERE IpAdd.Assigned=False"

  Set RSIp = Server.CreateObject("ADODB.Recordset")
  RSIp.Open SQL, "ISPStaticIP", adOpenDynamic, adLockOptimistic, adCmdText

  If RSIp.EOF AND RSIp.BOF Then
	sError = "ERROR retrieving static IP Address: " & err.number & " - " & CStr(Err.Description) & "<br>"
	oIspSetup.AspExtReportEvent CStr(sError), "Sign-Up Server", CInt(EVENTLOG_ERROR_TYPE)
    bContinueGetIp = False
    If (nDebugLevel > 0) Then
      Response.write sError
    End If
  Else
	Session("PermIPAddress") = rsIp("IpAddress")
	gIPRecord = rsIp("ID")
	RSIp("Assigned") = True
	RSIp("AssignedTo") = Session("UserName")
	RSIp.Update
	sError = "Success assigning static IP - " & Session("PermIPAddress")
    oIspSetup.AspExtReportEvent CStr(sError), "Sign-Up Server", CInt(EVENTLOG_SUCCESS_TYPE)
	If (nDebugLevel > 1) Then
	    Response.write "Permanent IP Address: " & Session("PermIPAddress") & Chr(46) & "<br>"
	End If
  End If
  
  RSIp.Close

  GetIpAddrFromDb = bContinueGetIp
End Function    'GetIpAddrFromDb

FUNCTION CheckString (s, endchar)
	pos = InStr(s, "'")
	While pos > 0
		s = Mid(s, 1, pos) & "'" & Mid(s, pos + 1)
		pos = InStr(pos + 2, s, "'")
	Wend
   CheckString="'" & s & "'" & endchar
END FUNCTION

FUNCTION GetNextVSNumber()
	On Error Resume Next
	
	szIISObject = "IIS://" & Session("WebServer") & "/w3svc"
	Set oIIS = GetObject(szIISObject)
	if (Err.Number <>0) then
		if (nDebugLevel > 0) then
			response.write "<p>Error creating remote directory (" & Session("WebServer") & "): " & err.number & " - " & err.description & "<br>"
		end if
		bContinue = False
		sError = "ERROR Creating remote directory (" & Session("WebServer") & "): " & err.number & " - " & err.description
		oIspSetup.AspExtReportEvent CStr(sError), "Sign-Up Server", CInt(EVENTLOG_ERROR_TYPE)
	else
		sError = "Success creating remote directory - " & Session("WebServer") & " - " & Session("WebDirRoot") & "\" & Session("FrontPageUserName")
		oIspSetup.AspExtReportEvent CStr(sError), "Sign-Up Server", CInt(EVENTLOG_SUCCESS_TYPE)
	end if
    
	If bContinue Then
		For Each Child in oIIS
			If IsNumeric(Child.Name) Then
    			strVSNum = Child.Name
			End If
		Next
	
		GetNextVSNumber = CStr(CInt(strVSNum) + 1)
	Else
		GetNextVSNumber = "0"
	End If
END FUNCTION

Function LogUserAccount()
	On Error Resume Next
	LogUserAccount = True
	Set Conn = Server.CreateObject("ADODB.Connection")
	Conn.Open "sbsAccounts"
	SQL = "Insert Into Accounts (" &_
			"Session, " &_
			"Contact, " &_
			"OrgName, " &_
			"Address1, " &_
			"Address2, " &_
			"City, " &_
			"State, " &_
			"Zip, " &_
			"Country, " &_
			"Phone, " &_
			"Fax, " &_
			"UserName, " &_
			"Password, " &_
			"SelectedDomain, " &_
			"PayType, " &_
			"POContact, " &_
			"POPhone, " &_
			"PONum, " &_
			"CardType, " &_
			"CardNum, " &_
			"CardExp, " &_
			"MailTag) " &_
			"VALUES ( "
		SQL = SQL & CheckString(CStr(Session.SessionID),",")
		SQL = SQL & CheckString(Session("Contact"),",")
		SQL = SQL & CheckString(Session("OrgName"),",")
		SQL = SQL & CheckString(Session("Address1"),",")
		SQL = SQL & CheckString(Session("Address2"),",")
		SQL = SQL & CheckString(Session("City"),",")
		SQL = SQL & CheckString(Session("State"), ",")
		SQL = SQL & CheckString(Session("Zip"), ",")
		SQL = SQL & CheckString(Session("Country"), ",")
		SQL = SQL & CheckString(Session("Phone"), ",")
		SQL = SQL & CheckString(Session("Fax"), ",")
		SQL = SQL & CheckString(Session("UserName"), ",")
		SQL = SQL & CheckString(Session("Password"),",")
		SQL = SQL & CheckString(Session("SelectedDomain"),",")
		SQL = SQL & CheckString(Session("PayType"),",")
		SQL = SQL & CheckString(Session("POContact"), ",")
		SQL = SQL & CheckString(Session("POPhone"), ",")
		SQL = SQL & CheckString(Session("PONum"), ",")
		SQL = SQL & CheckString(Session("CardType"), ",")
		SQL = SQL & CheckString(Session("CardNum"), ",")
		SQL = SQL & CheckString(Session("CardExp"), ",")
		SQL = SQL & CheckString(Session("RandomMachineName"), ")")
		Conn.Execute SQL
		if (Err.Number <>0) then
			if (nDebugLevel > 0) then
				response.write "<p>Error logging user account: " & err.number & " - " & err.description & "<br>"
			end if
			LogUserAccount = False
			sError = "Error logging user account: " & err.number & " - " & err.description
			oIspSetup.AspExtReportEvent CStr(sError), "Sign-Up Server", CInt(EVENTLOG_ERROR_TYPE)
		end if
End Function
</SCRIPT>

</html>