<%
' This file contains string resources for localization purposes

'Strings used in any/all pages
L_PageTitle_Text = "Sample Sign-up Server Customer Info Page"
L_ProgramTitle_Text = "ISP Resource Kit Sign-Up Server"
L_SetupTitle = "Internet Access Setup"
L_ApplicationTitle_Text = "Microsoft Small Business Server"
L_Cancel_Text = "Cancel"
L_Next_Text = "Next"
L_Back_Text = "Back"
L_Finish_Text = "Finish"
L_MsgBoxTitle_Text = "Sign-Up Error"
L_ErrorClick_Text = "Click here to exit the signup process."

'Form validation strings
L_EmptyPrefix_Text = "You did not enter a value into the "
L_EmptySuffix_Text = " field. This is a required field. Please enter it now."
L_NumPrefix_Text =  "You did not enter a correct value into the "
L_NumSuffix_Text = " field. This field cannot contain numeric characters."
L_CardPrefix_Text = "This is not a valid "
L_CardSuffix_Text = " credit card number. Please reenter it now."
L_CardExp_Text = "Your credit card has expired. Please enter another."
L_PassVerify_Text = "The password you entered was not correctly verified."
L_PassVerify2_Text = "Be sure that the confirmation password exactly matches the chosen password"

'Strings for signup.asp
L_SignupTitle_Text = "Enter Company Information"
L_Required_Text = "Required"
L_BoldText_Text = "Bold Text"
L_FirstName_Text = "First Name"
L_MiddleInitial_Text = "Middle Initial"
L_LastName_Text = "Last Name"
L_OrgName_Text = "Organization Name"
L_Address1_Text = "Address 1"
L_Address2_Text = "Address 2"
L_City_Text = "City"
L_State_Text = "State/Province"
L_Zip_Text = "ZIP/Postal Code"
L_Country_Text = "Country"
L_Phone_Text = "Business Phone"
L_Fax_Text = "Business Fax"

'Strings for pop.asp
L_PopTitle_Text = "Select Local Dial Up Number"
L_Region_Text = "Region"
L_ModemSpeed_Text = "Modem Speed"
L_DialUp_Text = "Dial Up Location"
L_AccessNumber_Text = "Access Number"
L_Min_Text = "Min"
L_Max_Text = "Max"

'Strings for services.asp
L_ServicesPassTitle_Text = "Select Password"
L_ServicesDomainTitle_Text = "Select Domain Name"
L_Password_Text = "Password"
L_VerifyPassword_Text = "Verify Password"
L_DomainExample_Text = "Domain name: (for example, 'smallbiz')"
L_DomainName_Text = "Domain Name"
L_DomainError_Text = "The domain you selected already exists, please choose another."
L_DomainAlpha_Text = "The domain you selected contains illegal characters. This field must be alphanumeric with no spaces."
L_DomainDesc1_Text = "Enter a domain name for your business.  The name you select will appear beneath the <strong>[isp.com]</strong> domain.  For example, choosing <strong>smallbiz</strong> gives you a website URL of <strong>www.smallbiz.[isp.com]</strong>." 
L_DomainDesc2_Text = "If you already have a registered domain name, please contact <strong>[ the ISP ]</strong> at <strong>[ ISP support number ]</strong>.  Enter a temporary domain name and continue the sign-up process."

'Strings for billing.asp
L_BillingTitle_Text = "Select Billing Option"
L_PayByCredit_Text = "Pay by Credit Card"
L_PayByPO_Text = "Pay by Purchase Order"
L_CardType_Text = "Card Type"
L_Visa_Text = "Visa"
L_MasterCard_Text = "MasterCard"
L_AmericanExpress_Text = "American Express"
L_CardNumber_Text = "Card Number"
L_Expiration_Text = "Expiration (MM/YY)"
L_FinancialContact_Text = "Financial Contact"
L_ContactPhone_Text = "Contact Phone #"
L_PONumber_Text = "PO#"

'Strings for cancel.asp
L_CancelMsg1_Text = "Are you sure you would like to cancel this sign-up transaction?"
L_CancelMsg2_Text = "Note: Data already entered will be lost."
L_Yes_Text = "Yes"
L_No_Text = "No"

'Strings for final.asp
L_RefFinish_Text = "Your information has already been processed."
L_SysBeingConfigured_Text = "The system is being configured for connectivity . . ."
L_Processing_Text = "Please wait . . . Processing . . ."
L_AccountCreated_Text = "Your ISP account has been successfully created!"
L_InternetPresence_Text = "Congratulations, you now have a presence on the Internet!"
L_FullDomainName_Text = "Your full domain name is:"
L_FrontPage_Text = "You may use FrontPage to access your web server and create your web site."
L_FrontPage2_Text = "Please use the following user name and the password you selected to publish your web pages:"
L_User_Text = "User:"
L_Secure_Text = "Please store this information in a secure location."
L_ClickHere_Text = "Click ""Finish"" to complete the signup process."
L_MsgDuplicate1_Text = "<b>A user account with this third-level domain already exists. "
L_MsgDuplicate2_Text = "<p>Please <a href=""signup.asp"">complete</a> the form again "
L_MsgDuplicate3_Text = "with a different domain selection.</b>"
L_MsgError1_Text = "<blockquote><strong>An error has occurred during the creation of your account.<br>"
L_MsgError2_Text = "Please contact your ISP for assistance.</strong></blockquote>"
L_Exit_Text = "Exit"
%>