' Include.vbs
'
' BASIC DATA VALIDATION FUNCTIONS:

Function CardType(N)
    Dim i, CheckSum, Prod
    MASK = "2121212121212121"
    Num=N
    
	if Num="" then
	    CardType="BLANK"
		exit function
	end if

'   Remove spaces
	NumDigits=Len(Num)
	TempNum=""
	for i=1 to NumDigits
		Digit=mid(Num,i,1)
		if Digit <> " " Then TempNum=TempNum & Digit
	next

'	Remove dashes
	TempNum2=""
	for i=1 to Len(TempNum)
		Digit=mid(TempNum,i,1)
		if Digit <> "-" Then TempNum2=TempNum2 & Digit
	next

'	Check for non-numbers
	for i=1 to len(TempNum2)
		if not isnumeric(mid(TempNum2,i,1)) then
			CardType="NONNUMBER"
			exit function
		end if
	next
	Num=TempNum2
	
'   Determine card type
    If Left(Num, 2) = "37" Then CardType = "AMERICANEXPRESS"
    If Left(Num, 1) = "4" Then CardType = "VISA" 
    If Left(Num, 1) = "5" Then CardType = "MASTERCARD"
       
'   Make card length = 16
    Select Case Len(Num)
        Case 13: Num = "000" & Num
        Case 14: Num = "00" & Num
        Case 15: Num = "0" & Num
        Case 16: Num = Num
        Case Else
            CardType="INVALID" 
            Exit Function
    End Select
    '   Calculate check sum
    CheckSum = 0
    For i = 1 To 16
        Prod = Mid(Num, i, 1) * Mid(MASK, i, 1)
        If Prod > 9 Then Prod = Prod - 9
        CheckSum = CheckSum + Prod
    Next 
    CheckSum = CheckSum Mod 10
    
'   Invalid card
    If CheckSum <> 0 Then
       CardType="INVALID"
       Exit Function
    End If
End Function

Function isCardMatch (strCardType, cardNumber)
	If strCardType = cardType(cardNumber) Then
		isCardMatch = True
	Else
		IsCardMatch = False
	End If
End Function



